<template>
  <div class=" row items-start q-gutter-md">
    <q-card class="my-card" style="width: 100%; border: none">
      <q-card-section>
        <div class="row" style="width: 100%">
          <div class="col-6">
            <div class="text-h6">{{ $route.params.category }}</div>
          </div>
          <div class="col-6" align="right">
            <q-btn color="orange" icon="arrow_back" label="Kembali" @click="$router.back()" />
          </div>
        </div>
      </q-card-section>

      <q-card-actions >
        <div class="row" style="width: 100%">
          <div class="col-6 q-pa-sm">
            <q-select v-model="selectedJenisProduk" filled :options="selectProductType" label="Jenis Produk" />
          </div>
          <div class="col-6 q-pa-sm">
            <q-select v-model="selectedKategori" filled :options="selectKategori" label="Kategori" style="width: 100%" />
          </div>
        </div>
      </q-card-actions>

      <q-card-section >
        <div class="row">
          <div class="col-6 q-pa-sm" v-for="item in product" >
            <q-card flat bordered style="height: 100%" >
              <q-img :src="item.main_image" v-if="item.main_image != ''" style="height: 200px; object-fit: cover" @click="goToDetail(item.id)"/>
              <q-img src="~assets/no_photo.png" v-else style="height: 200px; object-fit: cover" @click="goToDetail(item.id)"/>
              <q-card-section style="padding-top: 0px; white-space: nowrap;overflow: hidden;text-overflow: ellipsis">
                <div style="white-space: normal" class=" q-mt-sm q-mb-xs ellipsis-2-lines" @click="goToDetail(item.id)">{{ item.name_product }}</div>

                <div style="margin-top: 20px" class="text-caption text-grey" v-if="!item.price_prone_flag">Rp. {{ item.price }} </div>
                <div style="margin-top: 20px" class="text-caption text-grey" v-if="item.price_prone_flag">Rp. {{ item.starting_price }} - {{ item.final_price }} </div>

                <div class="row" style="margin-top: 10px">
                  <q-icon name="location_on"></q-icon>
                  <p class="ellipsis-2-lines" style="font-size: 10px">{{ (item.address.kota) ? item.address.kota.name : "Indonesia" }}</p>
                </div>
              </q-card-section>
            </q-card>
          </div>
        </div>
      </q-card-section>
    </q-card>
  </div>
</template>

<script>
export default {
  name: 'HalamanKategori',

  preFetch (store) {
    store.store.dispatch("product/getProductByKategori", store.currentRoute.params.category);
    store.store.dispatch("kategori/getSelectkategori")
    store.store.dispatch("ProductType/getSelectProductType")
  },

  data() {
    return {
      model: 'Google',
      options: [
        'Google', 'Facebook', 'Twitter', 'Apple', 'Oracle'
      ],
      selectedKategori: null,
      selectedJenisProduk: null
    }
  },

  methods: {
    goToDetail: function (id) {
      this.$router.push("/product/-m/" + id);
    }
  },

  computed: {
    product() {
      return this.$store.state.product.productListCategory;
    },

    categoryActive() {
      return this.$store.state.product.categoryActice;
    },

    paginate() {
      this.jmlHalaman = Math.floor(parseInt(this.product.length)/6);
      if (this.jmlHalaman == 0) {
        this.jmlHalaman = 1
      }

      let page = [];

      for (let i = 1; i <= this.jmlHalaman; i++) {
        page.push({
          label: i,
          value: i
        })
      }

      return page;
    },

    selectKategori() {
      let data = this.$store.state.kategori.selectKategori;
      if (!data) {
        return [];
      } else {
        return data;
      }
    },

    selectProductType() {
      return this.$store.state.ProductType.selectProductType;
    }
  },
}
</script>
